//+------------------------------------------------------------------
//|                                                     
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  DimGray
#property indicator_color2  DimGray
#property indicator_color3  DeepSkyBlue
#property indicator_color4  PaleVioletRed
#property indicator_color5  DeepSkyBlue
#property indicator_color6  PaleVioletRed
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_width5  2
#property indicator_width6  2

//
//
//
//
//

extern int HighLowPeriod = 10;

double peakUp[];
double peakDn[];
double legUp[];
double legDn[];
double limHi[];
double limLo[];
double leg[];
double trend[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,limHi);
      SetIndexBuffer(1,limLo);
      SetIndexBuffer(2,legUp);
      SetIndexBuffer(3,legDn);
      SetIndexBuffer(4,peakUp); SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,159);
      SetIndexBuffer(5,peakDn); SetIndexStyle(5,DRAW_ARROW); SetIndexArrow(5,159);
      SetIndexBuffer(6,trend);
      SetIndexBuffer(7,leg);
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,k,n,limit,counted_bars=IndicatorCounted();

   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
          limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
      peakUp[i] = EMPTY_VALUE;
      peakDn[i] = EMPTY_VALUE;
      limHi[i]  = High[ArrayMaximum(High,HighLowPeriod,i)];
      limLo[i]  = Low[ArrayMinimum(Low,HighLowPeriod,i)];
      leg[i]    = leg[i+1];
      
         if (limHi[i] > limHi[i+1]) leg[i] = MathMax( 1,leg[i+1]+1);
         if (limLo[i] < limLo[i+1]) leg[i] = MathMin(-1,leg[i+1]-1);
         if (leg[i] > 0 && leg[i] != leg[i+1]) { if (leg[i]>1) cleanUppeak(i); peakUp[i] = High[i]; }
         if (leg[i] < 0 && leg[i] != leg[i+1]) { if (leg[i]<1) cleanDnpeak(i); peakDn[i] = Low[i];  }
         
         //
         //
         //
         //
         //
         
         trend[i] = trend[i+1];
         if (peakUp[i] != EMPTY_VALUE || peakDn[i] != EMPTY_VALUE)
         {
            if (peakUp[i] != EMPTY_VALUE)
            {
                  for(n = 1; i+n < Bars && peakUp[i+n]==EMPTY_VALUE; n++) continue; if (peakUp[i+n]<peakUp[i]) trend[i] = 1;
                  for(n = 1; i+n < Bars && peakDn[i+n]==EMPTY_VALUE; n++) continue;
            }
            if (peakDn[i] != EMPTY_VALUE)
            {
                  for(n = 1; i+n < Bars && peakDn[i+n]==EMPTY_VALUE; n++) continue; if (peakDn[i+n]>peakDn[i]) trend[i] = -1;
                  for(n = 1; i+n < Bars && peakUp[i+n]==EMPTY_VALUE; n++) continue;
            }
            
            //
            //
            //
            //
            //
            
            if (trend[i] == 1)
                  if (peakUp[i] != EMPTY_VALUE) 
                        { legUp[i] = peakUp[i]; legUp[i+n] = peakDn[i+n]; }
                  else  { legUp[i] = peakDn[i]; legUp[i+n] = peakUp[i+n]; }
            else
                  if (peakUp[i] != EMPTY_VALUE) 
                        { legDn[i] = peakUp[i]; legDn[i+n] = peakDn[i+n]; }
                  else  { legDn[i] = peakDn[i]; legDn[i+n] = peakUp[i+n]; }
            
            //
            //
            //
            //
            //
            
            for(k = 1; k < n; k++)
            {
               if (trend[i] ==  1) { legUp[i+k] = legUp[i] + (legUp[i+n]-legUp[i])*k/n; legDn[i+k] = EMPTY_VALUE; }
  	            if (trend[i] == -1) { legDn[i+k] = legDn[i] + (legDn[i+n]-legDn[i])*k/n; legUp[i+k] = EMPTY_VALUE; }
            }  	            
         }               
   }
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

void cleanUppeak(int i)
{
   for (int k=i+1; k<Bars && peakDn[k]==EMPTY_VALUE; k++) 
         if (peakUp[k] != EMPTY_VALUE) { peakUp[k]=EMPTY_VALUE; break; }
}
void cleanDnpeak(int i)
{
   for (int k=i+1; k<Bars && peakUp[k]==EMPTY_VALUE; k++) 
         if (peakDn[k] != EMPTY_VALUE) { peakDn[k]=EMPTY_VALUE; break; }
}